#ifndef AST_H
#define AST_H

struct AST
{
  struct State tempStates[MEMORY_BLOCK];
  struct StateSet minStates;
  struct State *initialState;
};

struct AST *ASTNew(char **input, char **output, size_t length);
void ASTDelete(struct AST *ast);

void ASTMake(struct AST *ast, char **input, char **output, size_t length);
void ASTDestroy(struct AST *ast);

void ASTAddPair(struct AST *ast, char *currentWord, char *currentOutput);
void ASTRemovePair(struct AST *ast, char *currentWord);
unsigned ASTIsKeyPresent(struct AST *ast, char *word);
void ASTMakeTail(struct AST *ast, char *currentWord, size_t currentWordLen, char *currentOutput, size_t prefixLength);
void ASTMinimize(struct AST *ast, char *prevWord, size_t prevWordLen);
struct State *ASTGetInitialState(struct AST *ast);
void ASTPrint(struct AST *ast, FILE *file, unsigned normal);

#endif
