#include <stdio.h>
#include <malloc.h>

#include "memoryalloc.h"
#include "hashtable.h"
#include "hashes.h"
#include "letlittolithash.h"

struct HashtableType
LetLitToLitTableType = {
  LetLitHash,
  LetLitCopy,
  LiteralCopy,
  AtomDelete,
  LiteralDelete,
  LetLitEqual,
  NULL
};

struct HashtableType
LetLitToStringTableType = {
  LetLitHash,
  LetLitCopy,
  StringCopy,
  AtomDelete,
  AtomDelete,
  LetLitEqual,
  NULL
};

/* HashType */
size_t LetLitHash(void *data)
{
  struct LetLit * pll = (struct LetLit *)data;
  return
    (((size_t)pll->letter) * 11) +
    ((size_t)pll->literal);
}

/* CopyKeyType */
void *LetLitCopy(void *data)
{
  struct LetLit * pll = (struct LetLit *)data;
  struct LetLit * result = (struct LetLit *)
    SafeMalloc(sizeof (struct LetLit));
  result->letter = pll->letter;
  result->literal = pll->literal;
  return result;
}

/* EqualKeysType */
unsigned LetLitEqual(void *first, void *second)
{
  struct LetLit * a = (struct LetLit *)first;
  struct LetLit * b = (struct LetLit *)second;
  return
    (a->letter == b->letter) &&
    (a->literal == b->literal);
}
