#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <stdarg.h>

#include "memoryalloc.h"

void FatalError(char * format, ...)
{
  va_list marker;

  va_start(marker, format);
  vfprintf(stderr, format, marker);
  va_end(marker);

  abort();
}

void *SafeMalloc(const size_t size)
{
  void *result;

  result = malloc(size);
  if (result == NULL)
  {
    FatalError("Cannot allocate %u additional bytes!\n", ((unsigned)size));
  }
  return result;
}

