#ifndef STATESET_H
#define STATESET_H

struct StateSet
{
  struct Hashtable states;
  struct State *tempStates;
};

void StateSetMake(struct StateSet *set, struct State *tempStates);
void StateSetDestroy(struct StateSet *set);

struct StateSet *StateSetNew(struct State *tempStates);
void StateSetDelete(struct StateSet *set);

struct State *StateSetGetMember(struct StateSet *set, struct State *state);
void StateSetInsert(struct StateSet *set, struct State *state);
void StateSetRemove(struct StateSet *set, struct State *state);

struct State *StateSetFindMinimized(struct StateSet *set, struct State * s);
void StateSetDePropagate(struct StateSet *set, char *currentWord, size_t lastIndex);
struct State *StateSetClone(struct StateSet *set, struct State *parent, char c, struct State *from, struct State *to);

#endif
