#include <stdlib.h>
#include <string.h>
#include "memoryalloc.h"
#include "stringops.h"
#include "hashtable.h"
#include "hashes.h"
#include "letlittolithash.h"

char empty[1] = {'\0'};

size_t GetCommonPrefix(char *a, char *b, char *dest)
{
  size_t length = 0;

  if (a == NULL || b == NULL)
  {
    a = b = empty;
  }
  while (*a && *b && (*a == *b))
  {
    if (dest != a)
    {
      *dest = *a;
    }
    ++a;
    ++b;
    ++dest;
    ++length;
  }
  *dest = '\0';
  return length;
}

void GetMinusSized(size_t howMuch, char *fromWhere, char *dest)
{
  size_t length;

  length = strlen(fromWhere + howMuch);
  memmove(dest, fromWhere + howMuch, (length + 1) * sizeof (char));
}

char * AllocateAnotherString(char *likeWhat)
{
  size_t length;

  length = strlen(likeWhat);
  return (char *)SafeMalloc((length + 1) * sizeof (char));
}

void Concatenate(char *a, char *b, char *dest)
{
  size_t length;

  length = strlen(a);
  memmove(dest + length, b, (strlen(b) + 1) * sizeof (char));
  if (dest != a)
  {
    memmove(dest, a, length);
  }
}
