#ifndef VECTOR_H
#define VECTOR_H

#define NOT_IN_VECTOR ((size_t)(0xFFFFFFFF))

struct Vector
{
  size_t capacity;
  size_t length;
  int * data;
};

void VectorMake(struct Vector * v);
void VectorDestroy(struct Vector * v);

void VectorIncrementCapacity(struct Vector * v, size_t size);

void VectorAdd(struct Vector * v, int newData);
size_t VectorIndexOf(struct Vector * v, int data);
unsigned VectorRemove(struct Vector * v, int oldData);


#endif
